package cn.rankin.apiweb.utils;

import cn.rankin.apiweb.entity.GlobalHeader;
import javax.servlet.http.HttpServletRequest;
import java.util.Optional;

public class RequestHeaderManager {

    public static GlobalHeader parseHeader(HttpServletRequest request) {
        GlobalHeader globalHeader = new GlobalHeader();
        globalHeader.setUid(Optional.ofNullable(getRequestParameter(request, "uid")).orElse(""));
        globalHeader.setEid(Optional.ofNullable(getRequestParameter(request, "eid")).orElse(""));
        globalHeader.setSign(Optional.ofNullable(getRequestParameter(request, "sign")).orElse(""));
        globalHeader.setRequestId(Optional.ofNullable(getRequestParameter(request, "requestId")).orElse(""));
        globalHeader.setTerminal(Optional.ofNullable(getRequestParameter(request, "terminal")).orElse("").toLowerCase());
        return globalHeader;
    }

    /**
     * First get target parameter in header, if not exist, then get it in queryString or request body
     * @param request
     * @param key
     * @return
     */
    public static String getRequestParameter(HttpServletRequest request, String key){
        //first check header
        if (null != request.getHeader(key)){
            return request.getHeader(key);
        }
        return request.getParameter(key);
    }


}
